//pie.cs


datablock AudioProfile(PieExplosionSound)
{
   filename    = "./pieHit.wav";
   description = AudioClose3d;
   preload = false;
};

datablock AudioProfile(pieFireSound)
{
   filename    = "./pieFire.wav";
   description = AudioClose3d;
   preload = true;
};


//pie trail
datablock ParticleData(PieTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 800;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= " ";

	// Interpolation variables
	colors[0]	= "0.3 0.3 0.3 0.3";
	colors[1]	= "0.3 0.3 0.2 0.2";
	colors[2]	= "0.2 0.2 0.1 0.0";
	sizes[0]	= 0.45;
	sizes[1]	= 0.55;
	sizes[2]	= 0.35;
	times[0]	= 0.0;
	times[1]	= 0.05;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(PieTrailEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 1;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0.3;

   thetaMin         = 175.0;
   thetaMax         = 180.0;  

   particles = pieTrailParticle;

   useEmitterColors = true;
   uiName = "pie Trail";
};


//effects
datablock ParticleData(pieExplosionParticle)
{
	dragCoefficient		= 0.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 2.3;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 500;
	lifetimeVarianceMS	= 100;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/cloud";

	// Interpolation variables
	colors[0]	= "0.8 0.8 0.85 0.9";
	colors[1]	= "0.7 0.7 0.7 0.8";
	colors[2]	= "0.7 0.7 0.7 0.0";
	sizes[0]	= 4.0;
	sizes[1]	= 7.0;
	sizes[2]	= 6.0;
	times[0]	= 0.0;
	times[1]	= 0.7;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(pieExplosionEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   lifeTimeMS	   = 50;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 110;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "pieExplosionParticle";

//  uiName = "pie frosting";
//   emitterNode = TenthEmitterNode;
};

datablock ParticleData(pieExplosionParticle2)
{
	dragCoefficient		= 1.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 1.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 700;
	lifetimeVarianceMS	= 200;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/cloud";

	// Interpolation variables
	colors[0]	= "0.8 0.8 0.85 0.9";
	colors[1]	= "0.7 0.7 0.7 0.8";
	colors[2]	= "0.7 0.7 0.7 0.0";
	sizes[0]	= 4.0;
	sizes[1]	= 3.0;
	sizes[2]	= 2.0;
	times[0]	= 0.0;
	times[1]	= 0.5;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(pieExplosionEmitter2)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   lifetimeMS       = 10;
   ejectionVelocity = 15;
   velocityVariance = 5.0;
   ejectionOffset   = 0.0;
   thetaMin         = 140;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "pieExplosionParticle2";

//   useEmitterColors = true;
//   uiName = "pie Chunk";
//   emitterNode = HalfEmitterNode;
};

datablock ParticleData(PieDebrisTrailParticle)
{
	dragCoefficient		= 1.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.2;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 700;
	lifetimeVarianceMS	= 200;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/cloud";

	// Interpolation variables
	colors[0]	= "0.8 0.8 0.85 0.9";
	colors[1]	= "0.7 0.7 0.7 0.8";
	colors[2]	= "0.7 0.7 0.7 0.0";
	sizes[0]	= 0.3;
	sizes[1]	= 0.3;
	sizes[2]	= 0.2;
	times[0]	= 0.0;
	times[1]	= 0.5;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(pieDebrisTrailEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 5;
//   lifetimeMS       = 10;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 140;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "PieDebrisTrailParticle";

//   useEmitterColors = true;
//   uiName = "pie Chunk";
//   emitterNode = HalfEmitterNode;
};

datablock DebrisData(PieDebris)
{
   emitters = "pieDebrisTrailEmitter";

//	shapeFile = "./emptywheel.dts";

	render2D = true;
	texture = "base/data/particles/cloud";

   elasticity = 0.5;
   friction = 0.2;
   numBounces = 2;
   bounceVariance = 0;
   explodeOnMaxBounce = True;
   staticOnMaxBounce = False;
   snapOnMaxBounce = False;
   minSpinSpeed = -500;
   maxSpinSpeed = 500;
   render2D = True;
   lifetime = 3;
   lifetimeVariance = 0.5;
   velocity = 10;
   velocityVariance = 0.5;
   fade = false;
   useRadiusMass = true;
   baseRadius = 0.3;
   gravModifier = 1.2;
   terminalVelocity = 60;
   ignoreWater = true;

   Explosion = pieDebrisExplosion;
};

datablock ExplosionData(pieDebrisExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 100;

   emitter[0] = pieExplosionEmitter;
   //particleDensity = 30;
   //particleRadius = 1.0;

   faceViewer     = true;
   explosionScale = "0.2 0.2 0.2";
};

datablock ExplosionData(pieExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 150;

   soundProfile = pieExplosionSound;

   emitter[0] = pieExplosionEmitter;
   emitter[1] = pieExplosionEmitter2;
   //particleDensity = 30;
   //particleRadius = 1.0;

   debris = PieDebris;
   debrisNum = 5;
   debrisNumVariance = 2;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 180;
   debrisVelocity = 15;
   debrisVelocityVariance = 2;

   faceViewer     = true;
   explosionScale = "0.7 0.7 0.7";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 4;
   lightEndRadius = 3;
   lightStartColor = "0.45 0.3 0.1";
   lightEndColor = "0 0 0";

   //impulse
   impulseRadius = 3.5;
   impulseForce = 2000;

   //radius damage
   radiusDamage        = 40;
   damageRadius        = 3.5;
};

//projectile
AddDamageType("pieDirect",   '<bitmap:add-ons/Weapon_pie/CI_pie> %1',       '%2 <bitmap:add-ons/Weapon_pie/CI_pie> %1',1,1);
AddDamageType("pieRadius",   '<bitmap:add-ons/Weapon_pie/CI_pieRadius> %1', '%2 <bitmap:add-ons/Weapon_pie/CI_pieRadius> %1',1,0);
datablock ProjectileData(pieProjectile)
{
   projectileShapeName = "./pieProjectile.dts";
   directDamage        = 5;
   directDamageType  = $DamageType::pieDirect;
   radiusDamageType  = $DamageType::pieRadius;
   impactImpulse	   = 5;
   verticalImpulse	   = 0;
   explosion           = pieExplosion;
   particleEmitter     = pieTrailEmitter;

   brickExplosionRadius = 0;
   brickExplosionImpact = false; //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 20;
   brickExplosionMaxVolumeFloating = 20;

   muzzleVelocity      = 40;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 20000;
   fadeDelay           = 19500;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0.60;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "Pie";
};


//////////
// item //
//////////
datablock ItemData(pieItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./pie.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Pie";
	iconName = "./icon_pie";
	doColorShift = false;
	colorShiftColor = "0.400 0.196 0 1.000";

	 // Dynamic properties defined by the scripts
	image = pieImage;
	canDrop = true;
};

//function pie::onUse(%this,%user)
//{
//	//mount the image in the right hand slot
//	%user.mountimage(%this.image, $RightHandSlot);
//}

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(pieImage)
{
   // Basic Item properties
   shapeFile = "./pie.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = pieItem;
   ammo = " ";
   projectile = pieProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = false;
   colorShiftColor = "0.400 0.196 0 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]	= true;
	
	stateName[2]                    = "Charge";
	stateTransitionOnTimeout[2]	= "Armed";
	stateTimeoutValue[2]            = 0.7;
	stateWaitForTimeout[2]		= false;
	stateTransitionOnTriggerUp[2]	= "AbortCharge";
	stateScript[2]                  = "onCharge";
	stateAllowImageChange[2]        = false;
	
	stateName[3]			= "AbortCharge";
	stateTransitionOnTimeout[3]	= "Ready";
	stateTimeoutValue[3]		= 0.3;
	stateWaitForTimeout[3]		= true;
	stateScript[3]			= "onAbortCharge";
	stateAllowImageChange[3]	= false;

	stateName[4]			= "Armed";
	stateTransitionOnTriggerUp[4]	= "Fire";
	stateAllowImageChange[4]	= false;

	stateName[5]			= "Fire";
	stateTransitionOnTimeout[5]	= "Ready";
	stateTimeoutValue[5]		= 0.5;
	stateFire[5]			= true;
	stateSequence[5]		= "fire";
	stateScript[5]			= "onFire";
	stateWaitForTimeout[5]		= true;
	stateAllowImageChange[5]	= false;
	stateSound[5]				= pieFireSound;
};

function pieImage::onCharge(%this, %obj, %slot)
{
	%obj.playthread(2, spearReady);
}

function pieImage::onAbortCharge(%this, %obj, %slot)
{
	%obj.playthread(2, root);
}

function pieImage::onFire(%this, %obj, %slot)
{
	%obj.playthread(2, spearThrow);
	Parent::onFire(%this, %obj, %slot);
}
